.\" SPDX-License-Identifier: BSD-2-Clause

.\" Copyright (c) 2022 Alessio Chiapperini

.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.

.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.

.Dd April 20, 2022
.Dt RANGE 1
.Os
.Sh NAME
.Nm range
.Nd print a sequence of numbers or characters
.Sh SYNOPSIS
.Nm
.Fl h
.Op Fl s Ar sep
.Op Fl t Ar term
.Ar first
.Ar last
.Nm
.Fl h
.Op Fl s Ar sep
.Op Fl t Ar term
.Ar first
.Ar increment
.Ar last
.Sh DESCRIPTION
The
.Nm
utility prints numbers or characters from
.Ar first
to
.Ar last ,
in steps of
.Ar increment .
If
.Ar increment
is omitted, it defaults to either 1 or -1 depending on whether
.Ar first
is smaller than
.Ar last
or viceversa.
The sequence ends when the sum of the current element and
.Ar increment
would become greater than
.Ar last .
.Ar first ,
.Ar increment ,
and
.Ar last
are interpreted as signed integer values.
.Ar increment
is usually positive if
.Ar first 
is smaller than
.Ar last ,
and
.Ar increment
is usually negative if
.Ar first
is greater than
.Ar last .
.Ar increment
must be different than 0.
.Pp
The options are as follows:
.Bl -tag -width indent
.It Fl h
Print usage information and exit.
.It Fl s Ar sep
Use
.Ar sep
as the field delimiter in the sequence instead of
.Cm \en .
.It Fl t Ar term
Use
.Ar term
as the sequence terminator.
.El
.Sh "EXIT STATUS"
The
.Nm
utility exits 0 on success, and 1 if an error occurs.
.Sh EXAMPLES
Print the sequence of even numbers from 0 to 100:
.Bd -literal -offset ident
$ range 0 2 100
.Ed
.Pp
Print the sequence of letters a-z separated by a comma:
.Bd -literal -offset ident
$ range -s , 'a' 'z'
.Ed
.Pp
.Pp
Print the sequence of numbers from 10 to 5 with a default decrement of -1:
.Pp
.Bd -literal -offset ident
$ range 10 5
.Ed
.Pp
.Pp
Print the sequence of numbers from 1 to 10 separated by a horizontal tab and
terminated with a newline:
.Bd -literal -offset ident
$ range -s "\\t" -t "\\n" 1 10
.Ed
.Pp
.Sh SEE ALSO
.Xr seq 1
.Sh BUGS
The minimum and maximum values for the
.Ar first ,
.Ar last
and
.Ar increment
parameters are INT_MIN and INT_MAX respectively.
.Sh AUTHOR
.An Alessio Chiapperini Aq Mt alessio.chiapperini@\:nullbuffer.com 

